package su.a71.new_soviet.datagen;
// === ABANDON HOPE, YE WHO ENTER HERE ===

import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricModelProvider;
import net.minecraft.block.Block;
import net.minecraft.block.SlabBlock;
import net.minecraft.block.StairsBlock;
import net.minecraft.data.client.*;
import net.minecraft.registry.Registries;
import net.minecraft.util.Identifier;
import su.a71.new_soviet.registration.NSE_Blocks;

public class ModelGenerator extends FabricModelProvider {
    public ModelGenerator(FabricDataOutput generator) {
        super(generator);
    }

    // HELPER METHODS TO ACCOUNT FOR NON-FLAT TEXTURE STRUCTURE ====================

    public void registerDoor(BlockStateModelGenerator blockStateModelGenerator, Block doorBlock) {
        TextureMap textureMap = TextureMap.topBottom(
                Registries.BLOCK.getId(doorBlock).withPath((path) -> "block/doors/" + path + "_top"),
                Registries.BLOCK.getId(doorBlock).withPath((path) -> "block/doors/" + path + "_bottom"));
        TextureMap textureMapItem = TextureMap.layer0(Registries.BLOCK.getId(doorBlock).withPath((path) -> "item/doors/" + path));

        Identifier identifier = Models.DOOR_BOTTOM_LEFT.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier2 = Models.DOOR_BOTTOM_LEFT_OPEN.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier3 = Models.DOOR_BOTTOM_RIGHT.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier4 = Models.DOOR_BOTTOM_RIGHT_OPEN.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier5 = Models.DOOR_TOP_LEFT.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier6 = Models.DOOR_TOP_LEFT_OPEN.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier7 = Models.DOOR_TOP_RIGHT.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier8 = Models.DOOR_TOP_RIGHT_OPEN.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Models.GENERATED.upload(ModelIds.getItemModelId(doorBlock.asItem()), textureMapItem, blockStateModelGenerator.modelCollector);
        blockStateModelGenerator.blockStateCollector.accept(BlockStateModelGenerator.createDoorBlockState(doorBlock, identifier, identifier2, identifier3, identifier4, identifier5, identifier6, identifier7, identifier8));
    }

    public void registerCube(BlockStateModelGenerator blockStateModelGenerator, Block block, String texturePath) {
        TextureMap textureMap = TextureMap.all(Registries.BLOCK.getId(block).withPath((path) -> "block/" + texturePath + "/" + path));
        Identifier model_id = Models.CUBE_ALL.upload(block, textureMap, blockStateModelGenerator.modelCollector);
        blockStateModelGenerator.blockStateCollector.accept(BlockStateModelGenerator.createSingletonBlockState(block, model_id));
    }

    public void registerSlabStairs(BlockStateModelGenerator blockStateModelGenerator, Block parent, StairsBlock stairs, SlabBlock slab, String texturePath) {
        TextureMap textureMap = TextureMap.all(Registries.BLOCK.getId(parent).withPath((path) -> "block/" + texturePath + "/" + path));

//        Identifier slab_model = Models.SLAB.upload(slab, textureMap, blockStateModelGenerator.modelCollector);
//        Identifier slab_model_top = Models.SLAB_TOP.upload(slab, textureMap, blockStateModelGenerator.modelCollector);
//        Identifier slab_model_full = Models.CUBE_ALL.upload(slab, textureMap, blockStateModelGenerator.modelCollector);

        Identifier stairs_model = Models.STAIRS.upload(stairs, textureMap, blockStateModelGenerator.modelCollector);
        Identifier stairs_model_outer = Models.OUTER_STAIRS.upload(stairs, textureMap, blockStateModelGenerator.modelCollector);
        Identifier stairs_model_inner = Models.INNER_STAIRS.upload(stairs, textureMap, blockStateModelGenerator.modelCollector);

//        blockStateModelGenerator.registerItemModel(doorBlock.asItem());
//        BlockStateModelGenerator.createSlabBlockState(slab)
//        blockStateModelGenerator.blockStateCollector.accept(BlockStateModelGenerator.createSlabBlockState(slab, slab_model, slab_model_top, slab_model_full));
        blockStateModelGenerator.blockStateCollector.accept(BlockStateModelGenerator.createStairsBlockState(slab, stairs_model_inner, stairs_model, stairs_model_outer));
    }

    @Override
    public void generateBlockStateModels(BlockStateModelGenerator blockStateModelGenerator) {
        registerDoor(blockStateModelGenerator, NSE_Blocks.CHISELED_BIRCH_DOOR);
        registerDoor(blockStateModelGenerator, NSE_Blocks.CHISELED_SPRUCE_DOOR);
        registerDoor(blockStateModelGenerator, NSE_Blocks.CHISELED_OAK_DOOR);
        registerDoor(blockStateModelGenerator, NSE_Blocks.CHISELED_MANGROVE_DOOR);

        registerCube(blockStateModelGenerator, NSE_Blocks.SAND_TILES, "sand");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_SAND_TILES, "sand");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_SAND_TILES, "sand");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_SAND_TILES, "sand");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_CRACKED_SAND_TILES, "sand");
        registerCube(blockStateModelGenerator, NSE_Blocks.HERRINGBONE_SAND_TILES, "sand");
        registerCube(blockStateModelGenerator, NSE_Blocks.CROSS_SAND_TILES, "sand");
        registerCube(blockStateModelGenerator, NSE_Blocks.BIG_SAND_TILES, "sand");
        registerCube(blockStateModelGenerator, NSE_Blocks.SAND_BRICKS, "sand");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_SAND_BRICKS, "sand");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_SAND_BRICKS, "sand");
        registerCube(blockStateModelGenerator, NSE_Blocks.BIG_SAND_BRICKS, "sand");
        registerCube(blockStateModelGenerator, NSE_Blocks.BRICK_TILES, "brick");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_BRICK_TILES, "brick");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_BRICK_TILES, "brick");
        registerCube(blockStateModelGenerator, NSE_Blocks.DIRTY_BRICK_TILES, "brick");
        registerCube(blockStateModelGenerator, NSE_Blocks.DARK_BRICK_TILES, "brick");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_DARK_BRICK_TILES, "brick");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_DARK_BRICK_TILES, "brick");
        registerCube(blockStateModelGenerator, NSE_Blocks.DIRTY_DARK_BRICK_TILES, "brick");
        registerCube(blockStateModelGenerator, NSE_Blocks.GLAZED_BRICK_TILES, "brick");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_GLAZED_BRICK_TILES, "brick");
        registerCube(blockStateModelGenerator, NSE_Blocks.RED_BRICKS, "red");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_RED_BRICKS, "red");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_RED_BRICKS, "red");
        registerCube(blockStateModelGenerator, NSE_Blocks.TEAL_TILES, "teal");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_TEAL_TILES, "teal");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_TEAL_TILES, "teal");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_TEAL_TILES, "teal");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_CRACKED_TEAL_TILES, "teal");
        registerCube(blockStateModelGenerator, NSE_Blocks.GLAZED_TEAL_TILES, "teal");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_GLAZED_TEAL_TILES, "teal");
        registerCube(blockStateModelGenerator, NSE_Blocks.VARIATED_TEAL_TILES, "teal");
        registerCube(blockStateModelGenerator, NSE_Blocks.BIG_GREEN_TILES, "green");
        // Cracked big green tiles are variated!
        registerCube(blockStateModelGenerator, NSE_Blocks.GREEN_BRICKS, "green");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_GREEN_BRICKS, "green");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_GREEN_BRICKS, "green");
        registerCube(blockStateModelGenerator, NSE_Blocks.GREEN_BRICKS_2, "green");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_GREEN_BRICKS_2, "green");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_GREEN_BRICKS_2, "green");
        registerCube(blockStateModelGenerator, NSE_Blocks.AQUAMARINE_TILES, "aquamarine");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_AQUAMARINE_TILES, "aquamarine");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_AQUAMARINE_TILES, "aquamarine");
        registerCube(blockStateModelGenerator, NSE_Blocks.DIRTY_AQUAMARINE_TILES, "aquamarine");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_AQUAMARINE_TILES, "aquamarine");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_CRACKED_AQUAMARINE_TILES, "aquamarine");
        registerCube(blockStateModelGenerator, NSE_Blocks.GLAZED_AQUAMARINE_TILES, "aquamarine");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_GLAZED_AQUAMARINE_TILES, "aquamarine");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_DIORITE_TILES, "diorite");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_CRACKED_DIORITE_TILES, "diorite");
        registerCube(blockStateModelGenerator, NSE_Blocks.BIG_DIORITE_TILES, "diorite");
        registerCube(blockStateModelGenerator, NSE_Blocks.DIORITE_BRICKS, "diorite");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_DIORITE_BRICKS, "diorite");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_DIORITE_BRICKS, "diorite");
        registerCube(blockStateModelGenerator, NSE_Blocks.CALCITE_TILES, "calcite");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_CALCITE_TILES, "calcite");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_CALCITE_TILES, "calcite");
        registerCube(blockStateModelGenerator, NSE_Blocks.DIAGONAL_CALCITE_TILES, "calcite");
        registerCube(blockStateModelGenerator, NSE_Blocks.NII_WALL_1, "research_institute");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_NII_WALL_1, "research_institute");
        registerCube(blockStateModelGenerator, NSE_Blocks.NII_WALL_2, "research_institute");
        registerCube(blockStateModelGenerator, NSE_Blocks.NII_WALL_3, "research_institute");
        registerCube(blockStateModelGenerator, NSE_Blocks.DRIPSTONE_TILES, "dripstone");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_DRIPSTONE_TILES, "dripstone");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_DRIPSTONE_TILES, "dripstone");
        registerCube(blockStateModelGenerator, NSE_Blocks.DRIPSTONE_BRICKS, "dripstone");
        registerCube(blockStateModelGenerator, NSE_Blocks.DEEPSLATE_TILES, "deepslate");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_DEEPSLATE_TILES, "deepslate");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_DEEPSLATE_TILES, "deepslate");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_DEEPSLATE_TILES, "deepslate");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_CRACKED_DEEPSLATE_TILES, "deepslate");
        registerCube(blockStateModelGenerator, NSE_Blocks.DIAGONAL_DEEPSLATE_TILES, "deepslate");
        registerCube(blockStateModelGenerator, NSE_Blocks.LIGHT_BLUE_TILES, "light_blue");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_LIGHT_BLUE_TILES, "light_blue");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_LIGHT_BLUE_TILES, "light_blue");
        registerCube(blockStateModelGenerator, NSE_Blocks.VARIATED_LIGHT_BLUE_TILES, "light_blue");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_LIGHT_BLUE_TILES, "light_blue");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_CRACKED_LIGHT_BLUE_TILES, "light_blue");
        registerCube(blockStateModelGenerator, NSE_Blocks.GLAZED_LIGHT_BLUE_TILES, "light_blue");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_GLAZED_LIGHT_BLUE_TILES, "light_blue");
        registerCube(blockStateModelGenerator, NSE_Blocks.LIGHT_BLUE_BRICKS, "light_blue");
        // cracked light blue bricks are variated
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_LIGHT_BLUE_BRICKS, "light_blue");
        registerCube(blockStateModelGenerator, NSE_Blocks.BIG_GRANITE_TILES, "granite");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_GRANITE_TILES, "granite");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_CRACKED_GRANITE_TILES, "granite");
        registerCube(blockStateModelGenerator, NSE_Blocks.GREEN_WHITE_TILES, "green_white");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_GREEN_WHITE_TILES, "green_white");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_GREEN_WHITE_TILES, "green_white");
        registerCube(blockStateModelGenerator, NSE_Blocks.TUFF_TILES, "tuff");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_TUFF_TILES, "tuff");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_TUFF_TILES, "tuff");
        registerCube(blockStateModelGenerator, NSE_Blocks.BIG_TUFF_TILES, "tuff");
        registerCube(blockStateModelGenerator, NSE_Blocks.TUFF_BRICKS, "tuff");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_TUFF_BRICKS, "tuff");
        registerCube(blockStateModelGenerator, NSE_Blocks.MOSSY_TUFF_BRICKS, "tuff");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_WHITE_TILES, "white");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_CRACKED_WHITE_TILES, "white");
        registerCube(blockStateModelGenerator, NSE_Blocks.GLAZED_WHITE_TILES, "white");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_GLAZED_WHITE_TILES, "white");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_YELLOW_TILES, "yellow");
        registerCube(blockStateModelGenerator, NSE_Blocks.SMALL_CRACKED_YELLOW_TILES, "yellow");
        registerCube(blockStateModelGenerator, NSE_Blocks.WHITEWASH, "whitewash");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_WHITEWASH, "whitewash");
        registerCube(blockStateModelGenerator, NSE_Blocks.VERY_CRACKED_WHITEWASH, "whitewash");
        registerCube(blockStateModelGenerator, NSE_Blocks.WHITE_CONCRETE, "concrete");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_WHITE_CONCRETE, "concrete");
        registerCube(blockStateModelGenerator, NSE_Blocks.BEIGE_CONCRETE, "concrete");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_BEIGE_CONCRETE, "concrete");
        registerCube(blockStateModelGenerator, NSE_Blocks.BLUE_CONCRETE, "concrete");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_BLUE_CONCRETE, "concrete");
        registerCube(blockStateModelGenerator, NSE_Blocks.RED_CONCRETE, "concrete");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_RED_CONCRETE, "concrete");
        registerCube(blockStateModelGenerator, NSE_Blocks.YELLOW_CONCRETE, "concrete");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_YELLOW_CONCRETE, "concrete");
        registerCube(blockStateModelGenerator, NSE_Blocks.GREEN_CONCRETE, "concrete");
        registerCube(blockStateModelGenerator, NSE_Blocks.CRACKED_GREEN_CONCRETE, "concrete");
        registerCube(blockStateModelGenerator, NSE_Blocks.NII_FLOOR, "research_institute");
        registerCube(blockStateModelGenerator, NSE_Blocks.HERRINGBONE_ACACIA_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.CROSS_ACACIA_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.HERRINGBONE_OAK_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.CROSS_OAK_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.HERRINGBONE_BIRCH_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.CROSS_BIRCH_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.HERRINGBONE_CRIMSON_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.CROSS_CRIMSON_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.HERRINGBONE_DARK_OAK_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.CROSS_DARK_OAK_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.HERRINGBONE_JUNGLE_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.CROSS_JUNGLE_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.HERRINGBONE_MANGROVE_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.CROSS_MANGROVE_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.HERRINGBONE_SPRUCE_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.CROSS_SPRUCE_PLANKS, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.HERRINGBONE_PARQUET, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.STRAIGHT_PARQUET, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.SEPARATED_PARQUET, "floor/planks");
        registerCube(blockStateModelGenerator, NSE_Blocks.GREEN_LINOLEUM, "floor/linoleum");
        registerCube(blockStateModelGenerator, NSE_Blocks.BLUE_LINOLEUM, "floor/linoleum");
        registerCube(blockStateModelGenerator, NSE_Blocks.RED_LINOLEUM, "floor/linoleum");
        registerCube(blockStateModelGenerator, NSE_Blocks.GRAY_LINOLEUM, "floor/linoleum");
        registerCube(blockStateModelGenerator, NSE_Blocks.ORANGE_LINOLEUM, "floor/linoleum");
        registerCube(blockStateModelGenerator, NSE_Blocks.BROWN_LINOLEUM, "floor/linoleum");
        registerCube(blockStateModelGenerator, NSE_Blocks.CYAN_LINOLEUM, "floor/linoleum");
        registerCube(blockStateModelGenerator, NSE_Blocks.CROSS_ORANGE_LINOLEUM, "floor/linoleum");
        registerCube(blockStateModelGenerator, NSE_Blocks.CROSS_BROWN_LINOLEUM, "floor/linoleum");
        registerCube(blockStateModelGenerator, NSE_Blocks.INDUSTRIAL_WARNING, "industrial/warning");
        registerCube(blockStateModelGenerator, NSE_Blocks.GRAY_WARNING, "industrial/warning");
        registerCube(blockStateModelGenerator, NSE_Blocks.RED_WARNING, "industrial/warning");
        registerCube(blockStateModelGenerator, NSE_Blocks.ORANGE_WARNING, "industrial/warning");
        registerCube(blockStateModelGenerator, NSE_Blocks.YELLOW_WARNING, "industrial/warning");
        registerCube(blockStateModelGenerator, NSE_Blocks.LIME_WARNING, "industrial/warning");
        registerCube(blockStateModelGenerator, NSE_Blocks.GREEN_WARNING, "industrial/warning");
        registerCube(blockStateModelGenerator, NSE_Blocks.CYAN_WARNING, "industrial/warning");
        registerCube(blockStateModelGenerator, NSE_Blocks.LIGHT_BLUE_WARNING, "industrial/warning");
        registerCube(blockStateModelGenerator, NSE_Blocks.BLUE_WARNING, "industrial/warning");
        registerCube(blockStateModelGenerator, NSE_Blocks.PURPLE_WARNING, "industrial/warning");
        registerCube(blockStateModelGenerator, NSE_Blocks.MAGENTA_WARNING, "industrial/warning");
        registerCube(blockStateModelGenerator, NSE_Blocks.METAL_PLATING, "industrial");
        registerCube(blockStateModelGenerator, NSE_Blocks.GREEN_WALLPAPER, "wallpapers");
        registerCube(blockStateModelGenerator, NSE_Blocks.BROWN_WALLPAPER, "wallpapers");
        registerCube(blockStateModelGenerator, NSE_Blocks.BEIGE_WALLPAPER, "wallpapers");

//        registerSlabStairs(blockStateModelGenerator, NSE_Blocks.SAND_TILES, NSE_Blocks.SAND_TILES_STAIRS, NSE_Blocks.SAND_TILES_SLAB, "sand");
    }

    @Override
    public void generateItemModels(ItemModelGenerator itemModelGenerator) {
    }
}
